# ../rpg4go/Skill.py

# =============================================================================
# >> IMPORTS
# =============================================================================
from rpg4go.Level import Level

# =============================================================================
# >> CLASS: Skill
# =============================================================================
class Skill(Level):
    '''Define objects to hold skill's user and current level. Used as
a superclass for all the skills.'''
    
    # ===========
    # > Generic
    # ===========
    def __init__(self, user, level=0):
        '''Construct new Skill object, takes skill's user and level.'''

        # Initialize superclass' level attribute
        super().__init__(level)

        # Save skill's user
        self.user = user

    def action(self):
        '''Abstract class method, raises an error when a skill with no action gets activated.'''
        raise NotImplementedError("%s does not overwrite abstract 'action'-method for it's super %s" %(self.__class__, Skill))
