# ../rpg4go/skills.py

# =============================================================================
# >> IMPORTS
# =============================================================================
from rpg4go.Skill import Skill
import rpg4go.globals


# =============================================================================
# >> INITIALIZATION
# =============================================================================
def initSkills():
    '''Save all defined cSkills to rpg4go.globals.skill_list.'''

    # Loop through all Skill class' subclasses
    for skill in Skill.__subclasses__():

        # Add cSkill to skill_list
        rpg4go.globals.addSkill(skill)


# =============================================================================
# >> SKILL DEFINITIONS
# =============================================================================
class Health(Skill):
    event = "player_spawn"
    description = "Increases user's base hp"
    maxLevel = 12
    owner = "Mahi"
    
    def action(self):
        self.user.edict.SetPropInt("CBasePlayer.m_iHealth", 100 + self.level * 5)


class Speed(Skill):
    event = "player_spawn"
    description = "Grants user bonus movement speed"
    maxLevel = 5
    owner = "Mahi"

    def action(self):
        self.user.edict.SetPropFloat("CBasePlayer.localdata.m_flLaggedMovementValue", 1 + self.level * 0.05)


class Vampirism(Skill):
    event = "player_kill"
    description = "Drain small amount of health on kill"
    maxLevel = 4
    owner = "Mahi"

    def action(self, victim):
        health = self.user.edict.GetPropInt("CBasePlayer.m_iHealth")
        self.user.edict.SetPropInt("CBasePlayer.m_iHealth", health + self.level)
